package fitnesse.wikitext.parser;

import util.Maybe;

public class Nesting extends SymbolType implements Rule, Translation{
    public static final Nesting symbolType = new Nesting();

    public Nesting() {
        super("Nesting");
        wikiMatcher(new Matcher().string("!("));
        wikiRule(this);
        htmlTranslation(this);
    }

    public Maybe<Symbol> parse(Symbol current, Parser parser) {
        Symbol nesting = parser.parseTo(SymbolType.CloseNesting, ParseSpecification.nestingPriority);
        if (!parser.getCurrent().isType(SymbolType.CloseNesting)) return Symbol.nothing;
        current.add(nesting);
        return new Maybe<Symbol>(current);
    }

    public String toTarget(Translator translator, Symbol symbol) {
        return translator.translateTree(symbol) ;
    }
}
